//
//  DDAppDelegate.m
//  WorkingConnection
//
//  Created by Damien DeVille on 04/12/2011.
//  Copyright (c) 2011 Damien DeVille. All rights reserved.
//

#import "DDAppDelegate.h"
#import "DDDownloadOperation.h"

@interface DDAppDelegate ()

@property (nonatomic,strong) NSOperationQueue *queue;

@end

@implementation DDAppDelegate

@synthesize window = _window;
@synthesize queue = _queue;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	[self setQueue: [[NSOperationQueue alloc] init]];
	
	[self performSelector: @selector(createConnection) withObject: nil afterDelay: 0.0f];
}

- (void)createConnection
{
	NSURL *remoteURL = [NSURL URLWithString: @"http://apple.com"];
	DDDownloadOperation *downloadOperation = [[DDDownloadOperation alloc] initWithRemoteURL: remoteURL];
	[[self queue] addOperation: downloadOperation];
	
	DDDownloadOperation *blockDownloadOperation = downloadOperation;
	[downloadOperation setCompletionBlock: ^ {
		NSURLResponse *response = nil;
		NSError *error = nil;
		NSData *data = [blockDownloadOperation responseBlock](&response, &error);
		
		if (data == nil)
			NSLog(@"Oh Noooo: %@", error);
		else
			NSLog(@"Cool %@", response);
	}];
}

@end
